import { useState, useEffect } from 'react'
import reactLogo from './assets/react.svg'
import viteLogo from '/vite.svg'
import './App.css'
import {createBrowserHistory} from 'history';
import {Router} from 'react-router-dom'
import {createQueryPub} from './lib/pub';

const history = createBrowserHistory()

//console.log(createQueryPub)
//

const {queryPub, createQuery} = createQueryPub({
    queryFunc(route, id=''){
        return fetch(`https://swapi.dev/api/${route}/${id}`).then(res => res.json())
    },
    cacheTimeout: 5000,
    //hidePendingOnRefresh: false,
})

const {usePeopleQuery} = createQuery({promiseName: 'people',
                                     cacheTagFunc: (payload) => payload.results.map(man => ({type: 'people', id: +man.url.split('/')[5]}))})

//queryPub.subscribe(() => console.log(JSON.stringify(queryPub, null, 4)))





function App() {
    const queryState = usePeopleQuery('people')
    const [,setRandomState] = useState<number>()

    useEffect(() => {
        //setInterval(() => setRandomState(Math.random()), 1000)
    },[])

    console.log(queryState)

    const {status, payload,cacheTags} = queryState
    //console.log(JSON.stringify(cacheTags))
    return (
        <Router history={history}>
        {status === 'PENDING' && <h1>Loading</h1>}
        {status === 'FULFILLED' && payload.results.map(man => <h2 key={man.url}>{man.name}</h2>)}


        </Router>
    )
}

export default App
